#include <iostream>

using namespace std;

int main()
{
    int N,K,i,j,napitak[200000],Pocetak,kraj,resenje;
    cin>>N;
    cin>>K;
    Pocetak=0;
    kraj=N-1;
    for(i=0;i<=N-1;i++)
    {
        cin>>napitak[i];
    }
    for(i=0;i<=K-2;i++)
    {
        for(j=0;j<=K-2;j++)
        {
            if(napitak[Pocetak]>=napitak[kraj])
            {
                napitak[Pocetak]=napitak[Pocetak]- napitak[kraj];
                kraj=kraj-1;
                resenje=napitak[Pocetak];
            }
            if(napitak[Pocetak]<napitak[kraj])
            {
                napitak[kraj]=napitak[kraj]- napitak[Pocetak];
                Pocetak=Pocetak+1;
                resenje=napitak[kraj];
            }
        }
    }
    cout<<resenje;
    return 0;
}